<template>
  <div class="app-container pageSediment">
    <el-form v-show="showSearch" ref="queryForm" :inline="true" :model="queryParams" label-width="68px">
      <el-form-item label="院区名称" prop="yardName">
        <el-input
          v-model="queryParams.yardName"
          clearable
          placeholder="请输入院区名称"
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="el-icon-search" size="mini" type="cyan" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button
          v-hasPermi="['basis:yard:add']"
          icon="el-icon-plus"
          size="mini"
          type="primary"
          @click="handleAdd"
        >新增</el-button>
        <el-button
          v-hasPermi="['basis:yard:edit']"
          :disabled="single"
          icon="el-icon-edit"
          size="mini"
          type="success"
          @click="handleUpdate"
        >修改</el-button>
        <el-button
          v-hasPermi="['basis:yard:remove']"
          :disabled="multiple"
          icon="el-icon-delete"
          size="mini"
          type="danger"
          @click="handleDelete"
        >删除</el-button>
      </el-form-item>
    </el-form>

    <el-table ref="multipleTable" v-loading="loading"
              :data="yardList" border stripe tooltip-effect="light"  @row-click="handleRowClick"
              @selection-change="handleSelectionChange">
      <el-table-column align="center" type="selection" width="55" />
      <el-table-column align="left" fixed="left" label="院区编码" min-width="150" prop="yardCode" show-overflow-tooltip />
      <el-table-column align="left" fixed="left" label="院区名称" min-width="200" prop="yardName" show-overflow-tooltip  />
      <el-table-column :formatter="orgInfoQuery" align="left" label="机构" min-width="200" prop="orgId" show-overflow-tooltip/>
<!--      <el-table-column label="拼音码" align="left" prop="pyCode" width="150" />-->
      <!-- <el-table-column label="经度" align="center" prop="longitude" />
      <el-table-column label="纬度" align="center" prop="latitude" /> -->
      <el-table-column :formatter="isValidFormat" align="center" label="状态" prop="isValid" width="85"/>
      <el-table-column align="left" label="备注" min-width="400"  prop="remarks" show-overflow-tooltip/>
    </el-table>

    <pagination
      v-show="total>0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改院区信息对话框 -->
    <el-dialog v-dialogDrag :title="title" :visible.sync="open" append-to-body width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="所属机构" prop="orgId">
          <el-select
            v-model="form.orgId"
            clearable
            placeholder="请选择机构"
          >
            <el-option
              :key="0"
              :label="'全部'"
            :value= "''"
            />
          <el-option
            v-for="item in orgList"
            :key="item.id"
            :label="item.orgName"
            :value="item.orgCode"
          />
        </el-select>
      </el-form-item>
        <el-form-item label="院区名称" prop="yardName">
          <el-input v-model="form.yardName" placeholder="请输入院区名称" />
        </el-form-item>
        <el-form-item label="院区编码" prop="yardCode">
          <el-input v-model="form.yardCode" placeholder="请输入院区编码" />
        </el-form-item>
        <!-- <el-form-item label="经度" prop="longitude">
          <el-input v-model="form.longitude" placeholder="请输入经度" />
        </el-form-item>
        <el-form-item label="纬度" prop="latitude">
          <el-input v-model="form.latitude" placeholder="请输入纬度" />
        </el-form-item> -->
        <el-form-item label="状态" prop="isValid">
          <el-select v-model="form.isValid" placeholder="请选择状态">
            <el-option
              v-for="dict in isValidOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"  type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listYard, getYard, delYard, addYard, updateYard, exportYard } from "@/api/basis/yard";
import { listOrg } from "@/api/system/org";
import vPinyin from '@/utils/vue-py';//拼音码转换

export default {
  name: "Yard",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 院区信息表格数据
      yardList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 状态字典
      isValidOptions: [],
      //机构
      orgList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        orgId: null,
        yardName: null,
        yardCode: null,
        pyCode: null,
        isValid: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_normal_disable").then(response => {
      this.isValidOptions = response.data;
    });
    listOrg({isValid: 1}).then(response => {
      this.orgList = response.rows;
      console.log(this.orgList)
    });
  },
  methods: {
    handleRowClick(	row, column, event){
      this.$refs.multipleTable.toggleRowSelection(row);
    },
    /** 查询院区信息列表 */
    getList() {
      this.loading = true;
      listYard(this.queryParams).then(response => {
        this.yardList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 机构信息 */
     orgInfoQuery(row, column){
     let id = row.orgId
      for(var i = 0;i<this.orgList.length;i++){
          if(id == this.orgList[i].orgCode){
              return this.orgList[i].orgName;
          }
        }
        return '';
    },
    // 状态字典翻译
    isValidFormat(row, column) {
      return this.selectDictLabel(this.isValidOptions, row.isValid);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        yardName: null,
        yardCode: null,
        orgId: null,
        pyCode: null,
        longitude: null,
        latitude: null,
        isValid: null,
        createdById: null,
        createdByName: null,
        createdAt: null,
        updatedById: null,
        updatedByName: null,
        updatedAt: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加院区信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getYard(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改院区信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          //自动转换拼音码
          if( this.form.yardName !=null && this.form.yardName!=''){
             this.form.pyCode=vPinyin.chineseToPinYin(this.form.yardName);
          }
          if (this.form.id != null) {
            updateYard(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addYard(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除院区信息编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delYard(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有院区信息数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportYard(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    }
  }
};
</script>
